/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//機能名称 
//		  CMI パラメータパス クラス
//変更履歴
//			  2003.11.24	zcj  新規作成		
//
package jp.co.ntt.lms.lo.scorm.cbtcom;

//import java.util.StringTokenizer;
import java.util.List;
import java.util.ArrayList;
/**
 * CMI パラメータパス クラス <BR>
 * @author zhaicj
 * 
 */
public class CMIParameterPath {
	
	private int m_intCurIndex = 0;
	private int m_intCurTotal = 0;
	private final String m_strDelimiter = "."; 
	private String m_str = null;
	private List m_lstContent = new ArrayList();
	private CMITokenizer tokenizer = null;
	
	/**
	 * コンストラクタ<br>
	 * @param parameter パラメータパス
	 */
	public CMIParameterPath(String parameter) {
		m_str = parameter;
		m_intCurIndex = 0;
		if (m_str != null) {
			tokenizer = new CMITokenizer(m_str, m_strDelimiter);
			while(tokenizer.hasMoreTokens()) {
				String strToken = tokenizer.nextToken();
				m_lstContent.add(strToken);
			}
		}
	}

	/**	
	 * コンストラクタ<br>
	 */
	public CMIParameterPath() {
		m_str = null;
		m_intCurIndex = 0;
		tokenizer = null;   
	}
 
	/**
	 * クラスの終了処理 <BR>
	 */
	public void finalize() {
		m_intCurIndex = 0;
		m_str = null;
		m_lstContent = null;
		tokenizer = null;
	}
	  
	/**	
	 * パラメータのｎ番目の名前を取り出す。<br>
	 * @param index int 取り出し位置
	 * @return String 要素名
	 */
	public String getNthElement(int index) {
		try {
			return (String)m_lstContent.get( m_intCurIndex + index -1 );
		} catch (Exception ex) {
			return "";	
		}
	}

	/**	
	 * パラメータの先頭の名前を切り離して返す。<br>
	 * @return String 要素名
	 */
	public String popFirstElement() {
		if ( m_intCurIndex < m_lstContent.size()) {
			String strRet = (String)m_lstContent.get(m_intCurIndex);
			m_intCurIndex++;
			m_intCurTotal += ( strRet == null ) ? 0 : strRet.length();
			m_intCurTotal += 1;
			return strRet;
		} else {
			return "";
		}
	}
   
	/**
	 * 現在のパスを取得する。<br>
	 * @return String カレントパス名
	 */
	public String getPath() {
		if ( m_intCurIndex < m_lstContent.size() ) {
			String strPath = m_str.substring( m_intCurTotal );
			return strPath;
		} else {
			return "";
		}
	}

	/**
	 * 元々のパラメータパス全体を取得する。<br>
	 * @return String 元パス名
	 */
	public String getWholePath() {
		return m_str;
	}
 }